{    var   : }
{ N, RN }
Unit MNR12_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNR1Q_p, MNR1N_p;

procedure MNR12(var PM :Array of Real; var DX :Array of Real;
                var RV :Array of Real; var N :Integer; EPS :Real;
                var RN :Real; var PR :Integer);

implementation

procedure MNR12(var PM :Array of Real; var DX :Array of Real;
                var RV :Array of Real; var N :Integer; EPS :Real;
                var RN :Real; var PR :Integer);
var
I :Integer;
label
_1;
begin

PR := 0;
MNR1Q(PM,DX,RV,N);
for I:=1 to N do
 begin
_1:
  RV[I-1] := DX[I-1] -RV[I-1];
 end;
MNR1N(RV,N,RN);
if ( RN <= EPS ) 
 then PR := 1;
end;

end.
