Unit MNR2F_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR2F(var X :Array of Real; var XE :Array of Real;
                N :Integer; var A :Array of Real;
                var B :Array of Real; var I0 :Array of Integer;
                var PR :Integer);

implementation

procedure MNR2F(var X :Array of Real; var XE :Array of Real;
                N :Integer; var A :Array of Real;
                var B :Array of Real; var I0 :Array of Integer;
                var PR :Integer);
var
I :Integer;
label
_1,_2;
begin
{  OPMPOBAHE MACCBA I }
PR := 0;
for I:=1 to N do
 begin
  if ( I0[I-1] = 0 ) 
   then goto _2;
  if ( X[I-1] < B[I-1]-XE[I-1] ) 
   then goto _1;
  X[I-1] := B[I-1];
  I0[I-1] := 0;
  PR := 1;
  goto _2;
_1:
  if ( X[I-1] > A[I-1]+XE[I-1] ) 
   then goto _2;
  X[I-1] := A[I-1];
  I0[I-1] := 0;
  PR := 1;
_2:
 end;
end;

end.
