Unit MNR2G_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR2G(var X :Array of Real; var XE :Array of Real;
                N :Integer; var A :Array of Real;
                var B :Array of Real; var DX :Array of Real;
                var I0 :Array of Integer);

implementation

procedure MNR2G(var X :Array of Real; var XE :Array of Real;
                N :Integer; var A :Array of Real;
                var B :Array of Real; var DX :Array of Real;
                var I0 :Array of Integer);
var
I :Integer;
label
_1,_2;
begin
{   POBEPKA PAH }
for I:=1 to N do
 begin
  if ( I0[I-1] = 0 ) 
   then goto _2;
  if ( X[I-1]+DX[I-1] < B[I-1]-XE[I-1] ) 
   then goto _1;
  DX[I-1] := B[I-1]-X[I-1];
  goto _2;
_1:
  if ( X[I-1]+DX[I-1] > A[I-1]+XE[I-1] ) 
   then goto _2;
  DX[I-1] := A[I-1]-X[I-1];
_2:
 end;
end;

end.
