Unit MNR2H_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR2H(var X :Array of Real; N :Integer;
                var G :Array of Real; var A :Array of Real;
                var B :Array of Real; var I0 :Array of Integer;
                var I01 :Array of Integer; var PR :Integer);

implementation

procedure MNR2H(var X :Array of Real; N :Integer;
                var G :Array of Real; var A :Array of Real;
                var B :Array of Real; var I0 :Array of Integer;
                var I01 :Array of Integer; var PR :Integer);
var
I :Integer;
label
_1;
begin

PR := 0;
for I:=1 to N do
 begin
  if ( I01[I-1] = I0[I-1] )
   then goto _1;
  if ( X[I-1] = A[I-1] ) and ( -G[I-1] < 0 ) 
   then goto _1;
  if ( X[I-1] = B[I-1] ) and ( -G[I-1] > 0 ) 
   then goto _1;
  I01[I-1] := 1;
  PR := 1;
_1:
 end;
end;

end.
