{    var   : }
{ FE, N }
Unit MNR2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNR10_p, MNR11_p, MNR12_p, MNR1P_p, MNR1V_p, MNR13_p, MNR2G_p,
MNR24_p, MNR2F_p, MNR1N_p, MNR15_p, MNR16_p, MNR17_p, MNR18_p,
MNR19_p, MNR2H_p;

procedure MNR2R(var X :Array of Real; var XE :Array of Real;
                var I0 :Array of Integer; var A :Array of Real;
                var B :Array of Real; var N :Integer; FUNC :Proc_F1_MN;
                var F :Real; var FE :Real; GRAD :Proc_F2_MN;
                var G :Array of Real; var GE :Array of Real;
                var UP :Array of Real; var RM :Array of Real;
                var IRM :Array of Integer; var W :Integer);

implementation

procedure MNR2R(var X :Array of Real; var XE :Array of Real;
                var I0 :Array of Integer; var A :Array of Real;
                var B :Array of Real; var N :Integer; FUNC :Proc_F1_MN;
                var F :Real; var FE :Real; GRAD :Proc_F2_MN;
                var G :Array of Real; var GE :Array of Real;
                var UP :Array of Real; var RM :Array of Real;
                var IRM :Array of Integer; var W :Integer);
var
I,J,K,KN,IPM,PR,KMAX,IG1,ISS,IY,IRV,IAM,IBM,IHM,IDX,IT,N1,IK,I1,I2,KI,
   I5,I4,MATP :Integer;
S1,Z,Z1,RN,EPS,EPS1,AL,CDX,FT,C,HA,HOE,OPM,POBAH,E :Real;
FS :Array [0..3] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
{   BAPAHT METOA CCA  PEEH AA }
{   MHMA HA APAEEEE }
for I:=1 to N do
 begin
_1:
  IRM[I-1] := I0[I-1];
 end;
EPS := UP[0];
EPS1 := UP[1];
AL := UP[2];
CDX := UP[3];
KMAX := Trunc( RM[0] );
FS[0] := 1.0;
for I:=2 to 4 do
 begin
_2:
  FS[I-1] := FS[I-2]+1;
 end;
IG1 := 4;
ISS := IG1+N;
IY := ISS+N;
IRV := IY+N;
IAM := IRV+N;
IBM := Trunc(IAM+IntPower(N,2));
IHM := Trunc(IBM+IntPower(N,2));
IPM := Trunc(IHM+IntPower(N,2));
IDX := Trunc(IPM+IntPower(N,2));
IT := IDX+N;
FUNC(X,F,FE);
RM[1] := 1;
GRAD(X,RM[IG1-1],GE,IRM);
RM[2] := 1;
KN := 0;
RM[0] := 0;
{   HAAHOE OPMPOBAHE MATP }
_3:
MNR10(RM[IAM-1],RM[IBM-1],RM[IHM-1],RM[IPM-1],N);
K := IG1-1;
for I:=1 to N do
 begin
  KI := K+I;
_4:
  RM[KI-1] := IRM[I-1]*RM[KI-1];
 end;
_5:
N1 := 0;
for I:=1 to N do
 begin
  if ( IRM[I-1] = 0 ) 
   then goto _6;
  N1 := N1+1;
_6:
 end;
for J:=1 to N1 do
 begin
{   BCEHE BEKTOPA DX }
  W := 0;
  MNR11(RM[IDX-1],RM[IG1-1],RM[IHM-1],N);
{   POBEPKA HEHO HEABCMOCT }
  MNR12(RM[IPM-1],RM[IDX-1],RM[IRV-1],N,EPS,RN,PR);
  if ( PR = 0 ) 
   then goto _7;
{   OCK HEHYEBO CTPOK B MATPE P }
  MNR1P(RM[IPM-1],RM[IRV-1],N,EPS);
{   KOPPEKTPOBKA HAPABEH }
  MNR1V(RM[IDX-1],RM[IG1-1],RM[IRV-1],N,AL);
  goto _8;
{   EPECET MATP PM }
_7:
  MNR13(RM[IPM-1],RM[IRV-1],N,RN,RM[IHM-1]);
{   OCK YE TOK HA HAPABEH DX }
_8:
  MNR2G(X,XE,N,A,B,RM[IDX-1],IRM);
  I1 := IDX;
  I2 := IDX+N-1;
  MNR24(X,XE,F,RM[IDX-1],FUNC,FE,N,CDX,RM[1],RM[IRV-1],
       FT,PR);
  RM[0] := RM[0]+1;
  if ( PR = 0 ) 
   then goto _9;
  W := 1;
  KN := KN+1;
  if ( KN-2 ) < 0
   then goto _3
   else if ( KN-2 ) > 0
         then goto _18
         else goto _18;
_9:
  MNR2F(X,XE,N,A,B,IRM,PR);
  for I:=1 to 3 do
   begin
    I5 := 5-I;
    I4 := 4-I;
_10:
    FS[I5-1] := FS[I4-1];
   end;
  FS[0] := F-FT;
  F := FT;
  for I:=1 to 4 do
   begin
    if ( FS[I-1] > FE ) 
     then goto _12;
_11:
   end;
  W := 2;
  goto _18;
_12:
  KN := 0;
  K := IG1-1;
  for I:=1 to N do
   begin
_13:
    G[I-1] := RM[K+I-1];
   end;
  GRAD(X,RM[IG1-1],GE,IRM);
  K := IG1-1;
  for I:=1 to N do
   begin
    KI := K+I;
_14:
    RM[KI-1] := IRM[I-1]*RM[KI-1];
   end;
  RM[2] := RM[2]+1;
  MNR1N(RM[IG1-1],N,Z);
  MNR1N(GE,N,Z1);
  W := 3;
  if ( Z < Z1 ) 
   then goto _18;
  W := 4;
  if ( RM[0]-KMAX ) < 0
   then goto _15
   else if ( RM[0]-KMAX ) > 0
         then goto _18
         else goto _18;
_15:
  if ( PR = 1 ) 
   then goto _3;
{   EPECET MATP A,B,H }
  MNR15(RM[IDX-1],RM[IG1-1],G,RM[IAM-1],RM[IY-1],RM[ISS-1],N,
       S1);
  if ( S1 <= EPS1 ) 
   then goto _3;
  MNR16(RM[IAM-1],RM[ISS-1],S1,RM[IHM-1],N);
  MNR17(RM[IHM-1],RM[IBM-1],RM[ISS-1],RM[IRV-1],RM[IT-1],N);
  MNR18(RM[IAM-1],RM[IBM-1],RM[IHM-1],N);
_16:
 end;
MNR19(RM[IHM-1],RM[IBM-1],RM[IAM-1],N);
IK := N*N+IPM-1;
for I:=IPM to IK do
 begin
_17:
  RM[I-1] := 0.0;
 end;
goto _5;
_18:
GRAD(X,RM[IG1-1],GE,I0);
RM[2] := RM[2]+1;
MNR2H(X,N,RM[IG1-1],A,B,I0,IRM,PR);
if ( PR = 1 ) 
 then goto _3;
end;

end.
