{    var   : }
{ N, S1 }
Unit MNR15_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNR1Q_p, MNR1S_p;

procedure MNR15(var DX :Array of Real; var G1 :Array of Real;
                var G :Array of Real; var AM :Array of Real;
                var Y :Array of Real; var SS :Array of Real;
                var N :Integer; var S1 :Real);

implementation

procedure MNR15(var DX :Array of Real; var G1 :Array of Real;
                var G :Array of Real; var AM :Array of Real;
                var Y :Array of Real; var SS :Array of Real;
                var N :Integer; var S1 :Real);
var
I :Integer;
label
_1,_2;
begin

for I:=1 to N do
 begin
_1:
  Y[I-1] := G1[I-1]-G[I-1];
 end;
MNR1Q(AM,Y,SS,N);
for I:=1 to N do
 begin
_2:
  SS[I-1] := DX[I-1]-SS[I-1];
 end;
MNR1S(SS,Y,N,S1);
end;

end.
