Unit MNR1M_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR1M(var RM1 :Array of Real; var RM2 :Array of Real;
                var RM3 :Array of Real; N :Integer);

implementation

procedure MNR1M(var RM1 :Array of Real; var RM2 :Array of Real;
                var RM3 :Array of Real; N :Integer);
var
I,J,K :Integer;
S :Real;
label
_1,_2;
begin

for K:=1 to N do
 begin
  for I:=1 to N do
   begin
    S := 0.0;
    for J:=1 to N do
     begin
_1:
      S := S+RM1[(I-1)+(J-1)*N]*RM2[(J-1)+(K-1)*N];
     end;
_2:
    RM3[(I-1)+(K-1)*N] := S;
   end;
 end;
end;

end.
