{    var   : }
{ N, FT, FE }
Unit MNR24_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNR1N_p;

procedure MNR24(var XF :Array of Real; var XE :Array of Real;
                FF :Real; var DX :Array of Real; FUNC :Proc_F1_MN;
                var FE :Real; var N :Integer; CDX :Real; var NF :Real;
                var XT :Array of Real; var FT :Real; var PR :Integer);

implementation

procedure MNR24(var XF :Array of Real; var XE :Array of Real;
                FF :Real; var DX :Array of Real; FUNC :Proc_F1_MN;
                var FE :Real; var N :Integer; CDX :Real; var NF :Real;
                var XT :Array of Real; var FT :Real; var PR :Integer);
var
PR1,I :Integer;
Z :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
{   POEHE AA }
PR := 1;
MNR1N(DX,N,Z);
if ( Z <= 1 ) 
 then goto _2;
for I:=1 to N do
 begin
_1:
  DX[I-1] := DX[I-1]/Z;
 end;
_2:
for I:=1 to N do
 begin
_3:
  XT[I-1] := XF[I-1]+DX[I-1];
 end;
PR1 := 0;
FUNC(XT,FT,FE);
NF := NF+1.0;
if ( FT-FF+FE ) < 0
 then goto _6
 else if ( FT-FF+FE ) > 0
       then goto _4
       else goto _4;
_4:
for I:=1 to N do
 begin
  DX[I-1] := DX[I-1]/CDX;
  if ( Abs(DX[I-1]) < XE[I-1] ) 
   then goto _5;
  PR1 := 1;
_5:
 end;
if ( PR1 = 1 ) 
 then goto _2;
goto _8;
_6:
for I:=1 to N do
 begin
_7:
  XF[I-1] := XT[I-1];
 end;
PR := 0;
_8:
end;

end.
